#include "stdafx.h"
#include "minisd.h"

#define VERSION		"20011209"
#define VERSION_INFO	APP_TITLE " ("VERSION ")\n" \
			"Copyright (C) 2001 Naoyuki Sawa\n" \
			"\n" \
			": ExplorerhbO&hbv\n" \
			"폜: t@CIDELL[\n" \
			"XV: F5L[ōŐVɍXV"

#define STARTUP_PEX	"startup.pex"
#define ERR_INIT	"P/ECEɐڑł܂B"
#define ERR_REFRESH	"t@CXg̎擾Ɏs܂B"
#define ERR_NOSPACE	"󂫗eʂ܂B"
#define ERR_WRITE	"t@C݂̏Ɏs܂B"
#define ERR_INTERNAL	"G[܂B"
#define ERR_DELETE	"t@C̍폜Ɏs܂B"
#define ERR_STARTUP	STARTUP_PEX "͍폜/㏑ł܂B"
#define ERR_WSPACE	"󔒂܂ރt@C͓]ł܂B"
#define ASK_DELETE	"̃t@C폜Ă낵łH"

/****************************************************************************
 *	CMyApp
 ****************************************************************************/

CMyApp theApp;

BEGIN_MESSAGE_MAP(CMyApp, CWinApp)
	//{{AFX_MSG_MAP(CMyApp)
	//}}AFX_MSG
END_MESSAGE_MAP()

BOOL
CMyApp::InitInstance()
{
	/* AppWizardR[ĥ܂܁B */
	CMyDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if(nResponse == IDOK) {
	} else if(nResponse == IDCANCEL) {
	}
	return FALSE;
}

/****************************************************************************
 *	CMyDlg
 ****************************************************************************/

BEGIN_MESSAGE_MAP(CMyDlg, CDialog)
	//{{AFX_MSG_MAP(CMyDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_WM_SETFOCUS()
	ON_WM_DESTROY()
	ON_WM_SYSCOMMAND()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_NOTIFY_ICON, OnNotifyIcon)
END_MESSAGE_MAP()

CMyDlg::CMyDlg(CWnd* pParent)
: CDialog(CMyDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMyDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void
CMyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyDlg)
	DDX_Control(pDX, IDC_FILELIST, m_filelist);
	//}}AFX_DATA_MAP
}

BOOL
CMyDlg::OnInitDialog()
{
	int retval;
	CRect rect;
	CMenu* sys_menu;

	/* ܂NXĂт܂B */
	CDialog::OnInitDialog();

	/* ACRݒ肵܂B */
	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	/* VXej[Ƀo[Wǉ܂B */
	sys_menu = GetSystemMenu(FALSE);
	sys_menu->AppendMenu(MF_SEPARATOR);
	sys_menu->AppendMenu(MF_STRING, SC_ABOUT, "o[W(&A)...");

	/* ^XNgCւ̓o^/̂߂̍\̂pӂĂ܂B */
	memset(&m_nid, 0, sizeof m_nid);
	m_nid.cbSize = sizeof m_nid;
	m_nid.hWnd = m_hWnd;
	m_nid.uID = 1;
	m_nid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
	m_nid.uCallbackMessage = WM_NOTIFY_ICON;
	m_nid.hIcon = m_hIcon;
	strcpy(m_nid.szTip, APP_TITLE);

	/* t@CXgNCAg̈悢ςɊg܂B */
	GetClientRect(&rect);
	m_filelist.MoveWindow(&rect);

	/* t@CXg擾܂B */
	retval = m_filelist.refresh();
	if(!retval) {
		MessageBox(ERR_REFRESH, APP_TITLE, MB_ICONEXCLAMATION | MB_OK);
		/* p */
	}

	return TRUE;
}

void
CMyDlg::OnSysCommand(UINT nID, LPARAM lParam) 
{
	switch(nID) {
	case SC_MINIMIZE:
		/* EChE\ɂ܂B */
		ShowWindow(SW_HIDE);
		/* ^XNgCɓo^܂B */
		Shell_NotifyIcon(NIM_ADD, &m_nid);
		return;

	case SC_ABOUT:
		/* o[W\܂B */
		MessageBox(VERSION_INFO, APP_TITLE, MB_OK);
		return;
	}

	/* NX֗܂B */
	CDialog::OnSysCommand(nID, lParam);
}

void
CMyDlg::OnNotifyIcon(WPARAM /*wParam*/, LPARAM lParam)
{
	switch(lParam) {
	case WM_LBUTTONDOWN:
	case WM_MBUTTONDOWN:
	case WM_RBUTTONDOWN:
		/* ^XNgCo^܂B */
		Shell_NotifyIcon(NIM_DELETE, &m_nid);

		/* EChE\܂B */
		ShowWindow(SW_SHOW);

		/* ̃^C~OłAt@CXgXV܂B */
		m_filelist.refresh();

		break;
	}
}

void
CMyDlg::OnDestroy() 
{
	/* mɁA^XNgCo^܂B */
	Shell_NotifyIcon(NIM_DELETE, &m_nid);

	/* NX֗܂B */
	CDialog::OnDestroy();
}

void
CMyDlg::OnPaint() 
{
	/* AppWizardR[ĥ܂܁B */
	if(IsIconic()) {
		CPaintDC dc(this);
		SendMessage(WM_ICONERASEBKGND, (WPARAM)dc.GetSafeHdc(), 0);
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		dc.DrawIcon(x, y, m_hIcon);
	} else {
		CDialog::OnPaint();
	}
}

HCURSOR
CMyDlg::OnQueryDragIcon()
{
	/* AppWizardR[ĥ܂܁B */
	return (HCURSOR)m_hIcon;
}

void
CMyDlg::OnSize(UINT nType, int cx, int cy)
{
	/* ܂NXĂт܂B */
	CDialog::OnSize(nType, cx, cy);

	/* t@CXgNCAg̈悢ςɊg܂B
	 * WM_INITDIALOG̑OɌĂ΂܂B
	 * ͂܂m_filelistݒ肳ĂȂ̂ŁApX܂B
	 */
	if(m_filelist.m_hWnd != NULL) m_filelist.MoveWindow(0, 0, cx, cy);
}

void
CMyDlg::OnSetFocus(CWnd* pOldWnd) 
{
	/* ܂NXĂт܂B */
	CDialog::OnSetFocus(pOldWnd);

	/* t@CXgփtH[JX𗬂܂B */
	m_filelist.SetFocus();
}

/****************************************************************************
 *	CFileList
 ****************************************************************************/

BEGIN_MESSAGE_MAP(CFileList, CListBox)
	//{{AFX_MSG_MAP(CFileList)
	ON_WM_DROPFILES()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void
CFileList::OnDropFiles(HDROP hDropInfo)
{
	int retval, i, count;
	char src_path[_MAX_PATH], dst_path[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	char* p;

	CWaitCursor cursor;

	/* P/ECEɐڑ܂B */
	retval = ismInit();
	if(retval != 0) {
		MessageBox(ERR_INIT, APP_TITLE, MB_ICONEXCLAMATION | MB_OK);
		goto ABORT;
	}

	/* hbvꂽt@C擾܂B */
	count = DragQueryFile(hDropInfo, (UINT)-1, NULL, 0);

	/* et@Cɂ... */
	for(i = 0; i < count; i++) {
		/* ]t@C擾܂B */
		DragQueryFile(hDropInfo, i, src_path, sizeof src_path);

		/* ]t@C쐬܂B */
		_splitpath(src_path, drive, dir, fname, ext);
		_makepath(dst_path, NULL, NULL, fname, ext);

		/* 󔒂܂ރt@C͓]܂B
		 * ݂͂ł܂폜łAVXeAbvf[gŏȂȂ܂B
		 * ̃vÓAt@Cɋ󔒂܂܂ĂƐ삵܂񂪁A
		 * ismPFFSDelete()󔒂܂ރt@C𐳂Ȃ悤łB
		 */
		for(p = dst_path; *p != '\0'; p++) {
			if(iswspace(*p)) break;
		}
		if(*p != '\0') {
			MessageBox(ERR_WSPACE, APP_TITLE, MB_ICONEXCLAMATION | MB_OK);
			continue;
		}

		/* startup.pex͏㏑܂B */
		if(_strcmpi(dst_path, STARTUP_PEX) == 0) {
			MessageBox(ERR_STARTUP, APP_TITLE, MB_ICONEXCLAMATION | MB_OK);
			continue;
		}
RETRY:
		/* t@C]܂B */
		retval = ismPFFSWrite(dst_path, src_path);
		if(retval != 0) {
			retval = MessageBox(
				retval == ERR_PIECEIF_PFFS_EMPTY || ERR_PIECEIF_PFFS_DIR_EMPTY ? ERR_NOSPACE : ERR_WRITE,
				APP_TITLE, MB_ICONEXCLAMATION | MB_ABORTRETRYIGNORE);
			switch(retval) {
			case IDABORT:
				goto ABORT;
			case IDRETRY:
				goto RETRY;
			default: /*IDIGNORE*/
				break;
			}
		}
	}
ABORT:
	/* hbO&hbv܂B */
	DragFinish(hDropInfo);

	/* P/ECEؒf܂B */
	ismExit();

	/* t@CXgXV܂B */
	refresh();
}

void
CFileList::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	int retval, i, count, items[256];
	CString str;
	char fname[32];

	switch(nChar) {
	case VK_F5:
		/* t@CXgXV܂B */
		retval = refresh();
		if(!retval) {
			MessageBox(ERR_REFRESH, APP_TITLE, MB_ICONEXCLAMATION | MB_OK);
			/* p */
		}
		return;

	case VK_DELETE:
		CWaitCursor cursor;

		/* IACẽCfNX擾܂B */
		count = GetSelItems(sizeof items / sizeof *items, items);
		if(count <= 0) return; /* IACeȂ */

		/* zgɍ폜ĂmF܂B */
		retval = MessageBox(ASK_DELETE, APP_TITLE, MB_ICONQUESTION | MB_YESNO | MB_DEFBUTTON2);
		if(retval != IDYES) return;

		/* P/ECEɐڑ܂B */
		retval = ismInit();
		if(retval != 0) {
			MessageBox(ERR_INIT, APP_TITLE, MB_ICONEXCLAMATION | MB_OK);
			goto ABORT;
		}

		/* eACeɂ... */
		for(i = 0; i < count; i++) {
			/* ACe̕擾܂B */
			GetText(items[i], str);

			/* (TCY)At@Cɕ܂B */
			retval = sscanf(str, "%*d%s", fname);
			if(retval != 1) {
				MessageBox(ERR_INTERNAL, APP_TITLE, MB_ICONEXCLAMATION | MB_OK);
				goto ABORT;
			}

			/* startup.pex͏܂B */
			if(_strcmpi(fname, STARTUP_PEX) == 0) {
				MessageBox(ERR_STARTUP, APP_TITLE, MB_ICONEXCLAMATION | MB_OK);
				continue;
			}
RETRY:
			/* t@C폜܂B */
			retval = ismPFFSDelete(fname);
			if(retval != 0) {
				retval = MessageBox(ERR_DELETE, APP_TITLE, MB_ICONEXCLAMATION | MB_ABORTRETRYIGNORE);
				switch(retval) {
				case IDABORT:
					goto ABORT;
				case IDRETRY:
					goto RETRY;
				default: /*IDIGNORE*/
					break;
				}
			}
		}
ABORT:
		/* P/ECEؒf܂B */
		ismExit();

		/* t@CXgXV܂B */
		refresh();

		return;
	}

	/* NX֗܂B */
	CListBox::OnKeyDown(nChar, nRepCnt, nFlags);
}

int
CFileList::refresh()
{
	int retval, size;
	char *p, buf[32 * 256], fname[32], str[6 + 1 + 32];

	CWaitCursor cursor;

	/* Xg{bNXɂ܂B */
	ResetContent();

	/* P/ECEɐڑ܂B */
	retval = ismInit();
	if(retval != 0) {
		ismExit();
		return 0;
	}

	/* t@CXg擾܂B */
	retval = ismPFFSDir(buf, sizeof buf, 0/*tÖӖs*/);
	if(retval != 0) {
		ismExit();
		return 0;
	}

	/* t@CPʂɕ܂B */
	p = strtok(buf, "\n");
	for(;;) {
		/* vTCYs𔭌甲܂B */
		if(*p != '+') break;

		/* (ԍ)ATCYAt@Cɕ܂B */
		retval = sscanf(p + 1, "%*d:%d%s", &size, fname);
		if(retval != 2) {
			ismExit();
			return 0;
		}

		/* Xg{bNXɒǉ܂B */
		sprintf(str, "%6d %s", size, fname);
		AddString(str);

		/* ̃t@CցB
		 * vTCYsȂŏI邱Ƃ͂Ȃ͂B
		 */
		p = strtok(NULL, "\n");
		if(p == NULL) {
			ismExit();
			return 0;
		}
	}

	/* P/ECEؒf܂B */
	ismExit();
	return 1;
}
